Loading...
Searching...
No Matches
Circulation< GR, LM, UM, SM, TR >::SetElevator< T > Struct Template Reference

## Detailed Description

template<typename GR, typename LM, typename UM, typename SM, typename TR>
template<typename T>
struct lemon::Circulation< GR, LM, UM, SM, TR >::SetElevator< T >

Named parameter for setting Elevator type. If this named parameter is used, then an external elevator object must be passed to the algorithm using the elevator() function before calling run() or init().

See also
  SetStandardElevator

`#include <lemon/circulation.h>`

Inheritance diagram for Circulation< GR, LM, UM, SM, TR >::SetElevator< T >:
[legend]

## Additional Inherited Members

Public Types inherited from Circulation< Digraph, LowerMap, UpperMap, SupplyMap, SetElevatorTraits< T > >
typedef SetElevatorTraits< T > | Traits
| The traits class of the algorithm.
typedef Traits::Digraph | Digraph
| The type of the digraph the algorithm runs on.
typedef Traits::Value | Value
| The type of the flow and supply values.
typedef Traits::LowerMap | LowerMap
| The type of the lower bound map.
typedef Traits::UpperMap | UpperMap
| The type of the upper bound (capacity) map.
typedef Traits::SupplyMap | SupplyMap
| The type of the supply map.
typedef Traits::FlowMap | FlowMap
| The type of the flow map.
typedef Traits::Elevator | Elevator
| The type of the elevator.
typedef Traits::Tolerance | Tolerance
| The type of the tolerance.
Public Member Functions inherited from Circulation< Digraph, LowerMap, UpperMap, SupplyMap, SetElevatorTraits< T > >
| Circulation (const Digraph &graph, const LowerMap &lower, const UpperMap &upper, const SupplyMap &supply)
| Constructor.
| ~Circulation ()
| Destructor.
Circulation & | lowerMap (const LowerMap &map)
| Sets the lower bound map.
Circulation & | upperMap (const UpperMap &map)
| Sets the upper bound (capacity) map.
Circulation & | supplyMap (const SupplyMap &map)
| Sets the supply map.
Circulation & | flowMap (FlowMap &map)
| Sets the flow map.
Circulation & | elevator (Elevator &elevator)
| Sets the elevator used by algorithm.
const Elevator & | elevator () const
| Returns a const reference to the elevator.
Circulation & | tolerance (const Tolerance &tolerance)
| Sets the tolerance used by the algorithm.
const Tolerance & | tolerance () const
| Returns a const reference to the tolerance.
void | init ()
| Initializes the internal data structures.
void | greedyInit ()
| Initializes the internal data structures using a greedy approach.
bool | start ()
| Executes the algorithm.
bool | run ()
| Runs the algorithm.
Value | flow (const Arc &arc) const
| Returns the flow value on the given arc.
const FlowMap & | flowMap () const
| Returns a const reference to the flow map.
bool | barrier (const Node &node) const
| Returns `true` if the given node is in a barrier.
void | barrierMap (BarrierMap &bar) const
| Gives back a barrier.
bool | checkFlow () const
| Check if the found flow is a feasible circulation.
bool | checkBarrier () const
| Check whether or not the last execution provides a barrier.